#ifndef STRAPDISPLAYINPUTMANAGER_h
#define STRAPDISPLAYINPUTMANAGER_h

// ----------------------------------------
// Includes
// ----------------------------------------
#include "PL_smallLegio.h"          // Display-specific library for 4pigment media (Legio, 6colors)

// Defines
#define SOFTPOT_LEFT_PIN     A0
#define SOFTPOT_MIDDLE_PIN   A2
#define SOFTPOT_RIGHT_PIN    A1
#define EPD_RST_PINO         12
#define EPD_BUSY_PINO        9
#define EPD_CS_PINO          5
#define SOFTPOT_PUFFER_SIZE  5

// Enums
enum SOFTPOT_ID {softPotLeftID = 0, softPotMiddleID, softPotRightID};

// Helper Class
class InputRegion {
  private:
  public:
    short minYVal; //0-1023 = softpot values
    short maxYVal; //0-1023 = softpot values
    short xVal;    // 1-3; # of physical softpots sensors
};

// Class
class StrapDisplayInputManager{

  private:
    int inputBuffer[SOFTPOT_PUFFER_SIZE][3];
    int inputBufferIndex = 0;
    bool bDebugSoftPots = false;
    int current_application_state = 0;
    PL_smallLegio *epdRef;
    void printSoftPotsVals(int pufferPos);

  public:
    void init(PL_smallLegio *epd);
    void debugSoftPots(bool debugSoftPotsVals);
    void readSoftPots();
    bool checkInputRegion(InputRegion region, int triggerThreshold = 5);
};

 #endif
