// ----------------------------------------
// Includes
// ----------------------------------------
#include "StrapDisplayInputManager.h"
#include "screens/app_appdrawer.h"
#include "strapDisplayAppDrawer.h"        

void StrapDisplayAppDrawer::show(){
  updateNavState();  
  epdRef->clearScreen(EPD_BLACK);

    appIndexStart = app_internal_state*6;
    int x = amountStrapDisplayApps-appIndexStart;
    if(x>6) x = 6;
    appIndexEnd = appIndexStart + x;
    
  for (int j=0; j < (sizeof(epdPigments) / sizeof(epdPigments[0])); j++){
    for (int i=appIndexStart; i<appIndexEnd; i++){
      int xOffset = ((int)((((i-app_internal_state*6)+2)/2))-1);
      int yOffset;
      if (i % 2 == 0) {
        yOffset=85; 
        registeredAppsInputRegions[i].xVal = softPotLeftID;
        registeredAppsInputRegions[i].maxYVal = 740-((xOffset)*200);
        registeredAppsInputRegions[i].minYVal = 740-((xOffset+1)*200);
        }
      else {
        yOffset= 85 -50 -17;
        registeredAppsInputRegions[i].xVal = softPotRightID;
        registeredAppsInputRegions[i].maxYVal = 740-((xOffset)*200);
        registeredAppsInputRegions[i].minYVal = 740-((xOffset+1)*200);
        }
        
      if(j==0){
        if(prevPageActive)epdRef->fillTriangle(17,87,17,67,7,77,EPD_BLACK);
        if(nextPageActive)epdRef->fillTriangle(214,87,214,67,224,77,EPD_BLACK);
      }    
      
      registeredApps[i]->drawAppIcon((xOffset*50)+((xOffset+1)*15)+10,yOffset,j);
      }
    epdRef->updateLegio(epdPigments[j]);
    epdRef->clear();
  }
}

void StrapDisplayAppDrawer::registerStrapDisplayApp(StrapDisplayApp *strapDisplayApp){
  registeredApps[amountStrapDisplayApps] = strapDisplayApp;
  amountStrapDisplayApps++;
}

void StrapDisplayAppDrawer::init(){
  prevPage.minYVal = 650;
  prevPage.maxYVal = 800;
  prevPage.xVal = softPotMiddleID;

  nextPage.minYVal = 100;
  nextPage.maxYVal = 200;
  nextPage.xVal = softPotMiddleID;
}

int StrapDisplayAppDrawer::runApplication(){  

  // Read SoftPot Values...
  strapDisplayCoreRef->readSoftPots();

  // App Drawer Page Navigation
  if (strapDisplayCoreRef->checkInputRegion(nextPage) && nextPageActive){
    app_internal_state++;
    show();
    return APP_IS_RUNNING;
  }
  else if (strapDisplayCoreRef->checkInputRegion(prevPage) && prevPageActive){
    app_internal_state--;
    show();
    return APP_IS_RUNNING;
  }
    
  for (int i=appIndexStart; i<appIndexEnd; i++){
    if (strapDisplayCoreRef->checkInputRegion(registeredAppsInputRegions[i])){
      return registeredApps[i]->getApplicationID();
    }
  }

  return APP_IS_RUNNING;
}

void StrapDisplayAppDrawer::updateNavState(){
  if (app_internal_state==0){
    prevPageActive = false;
    if(amountStrapDisplayApps>6){nextPageActive = true;}
    else{nextPageActive = false;}    
  }
  else{
    prevPageActive = true;
    if(amountStrapDisplayApps-((app_internal_state+1)*6)>0){nextPageActive = true;}
    else{nextPageActive = false;} 
  }
  
}
