// Includes
#include "strapDisplayAppMediaControls.h"
#include "StrapDisplayInputManager.h"
#include "screens/app_mediacontrols.h"    

    
void StrapDisplayAppMediaControls::drawAppIcon(int xPos, int yPos, int color){

  if(color == iconBlackPixel){
      epdRef->drawBitmap(xPos,yPos,StrapDisplayAppMediaControls_ICON_RED,50,50,EPD_BLACK);
      epdRef->drawRect(xPos-1,yPos-1,50+2,50+2,EPD_BLACK);
      epdRef->drawRect(xPos-2,yPos-2,50+4,50+4,EPD_BLACK);
  }
  else if(color == iconRedPixel){
    epdRef->drawBitmap(xPos,yPos,StrapDisplayAppMediaControls_ICON_RED,50,50,EPD_BLACK);
  }
}

void StrapDisplayAppMediaControls::init(){
  
  mediaControlsAppButton.minYVal = 235;
  mediaControlsAppButton.maxYVal = 325;
  mediaControlsAppButton.xVal = softPotLeftID;

  mediaControlsBackButton.minYVal = 700;
  mediaControlsBackButton.maxYVal = 780;
  mediaControlsBackButton.xVal = softPotMiddleID;

  mediaControlsNextButton.minYVal = 135;
  mediaControlsNextButton.maxYVal = 235;
  mediaControlsNextButton.xVal = softPotRightID;

  mediaControlsPrevButton.minYVal = 550;
  mediaControlsPrevButton.maxYVal = 750;
  mediaControlsPrevButton.xVal = softPotRightID;

  mediaControlsMuteButton.minYVal = 280;
  mediaControlsMuteButton.maxYVal = 420;
  mediaControlsMuteButton.xVal = softPotLeftID;

  mediaControlsIncreaseButton.minYVal = 150;
  mediaControlsIncreaseButton.maxYVal = 250;
  mediaControlsIncreaseButton.xVal = softPotLeftID;

  mediaControlsDecreaseButton.minYVal = 520;
  mediaControlsDecreaseButton.maxYVal = 740;
  mediaControlsDecreaseButton.xVal = softPotLeftID;

  mediaControlsPauseButton.minYVal = 420;
  mediaControlsPauseButton.maxYVal = 560;
  mediaControlsPauseButton.xVal = softPotMiddleID;

  mediaControlsPlayButton.minYVal = 185;
  mediaControlsPlayButton.maxYVal = 325;
  mediaControlsPlayButton.xVal = softPotMiddleID;
}

void StrapDisplayAppMediaControls::show(){  
  epdRef->clearScreen(EPD_BLACK);
  delay(1000);
  epdRef->showImage(SCREEN_MEDIA_MODERN_I);
  delay(1000);
}

int StrapDisplayAppMediaControls::runApplication(){  

  // Read SoftPot Values...
  strapDisplayCoreRef->readSoftPots();

    if (strapDisplayCoreRef->checkInputRegion(mediaControlsBackButton)) {
        return APP_EXIT;
      }
      else if(strapDisplayCoreRef->checkInputRegion(mediaControlsNextButton)){
        BLEHidRef->consumerKeyPress(HID_USAGE_CONSUMER_SCAN_NEXT);
        delay(60);  
        BLEHidRef->consumerKeyRelease(); 
        delay(60);
        uint8_t keycodes[6] = {HID_KEY_ARROW_RIGHT, HID_KEY_NONE , HID_KEY_NONE , HID_KEY_NONE , HID_KEY_NONE , HID_KEY_NONE};
        BLEHidRef->keyboardReport(0, keycodes);
        delay(250);
        BLEHidRef->keyRelease();
        delay(250);
        return APP_IS_RUNNING;            
      }
      else if(strapDisplayCoreRef->checkInputRegion(mediaControlsPrevButton)){
        BLEHidRef->consumerKeyPress(HID_USAGE_CONSUMER_SCAN_PREVIOUS);
        delay(60);  
        BLEHidRef->consumerKeyRelease(); 
        delay(60);
        uint8_t keycodes[6] = {HID_KEY_ARROW_LEFT, HID_KEY_NONE , HID_KEY_NONE , HID_KEY_NONE , HID_KEY_NONE , HID_KEY_NONE};
        BLEHidRef->keyboardReport(0, keycodes);
        delay(250);
        BLEHidRef->keyRelease();
        delay(250);
        return APP_IS_RUNNING;       
      }
      else if(strapDisplayCoreRef->checkInputRegion(mediaControlsMuteButton)){  
        BLEHidRef->consumerKeyPress(HID_USAGE_CONSUMER_MUTE);
        delay(250);  
        BLEHidRef->consumerKeyRelease(); 
        delay(250);
        return APP_IS_RUNNING;        
      }
      else if(strapDisplayCoreRef->checkInputRegion(mediaControlsIncreaseButton)){
        BLEHidRef->consumerKeyPress(HID_USAGE_CONSUMER_VOLUME_INCREMENT);
        delay(250);  
        BLEHidRef->consumerKeyRelease(); 
        delay(250);
        return 0;     
      }
      else if(strapDisplayCoreRef->checkInputRegion(mediaControlsDecreaseButton)){
        BLEHidRef->consumerKeyPress(HID_USAGE_CONSUMER_VOLUME_DECREMENT);
        delay(250);  
        BLEHidRef->consumerKeyRelease(); 
        delay(250);
        return APP_IS_RUNNING;
      }
      else if(strapDisplayCoreRef->checkInputRegion(mediaControlsPauseButton)){
        BLEHidRef->consumerKeyPress(HID_USAGE_CONSUMER_PLAY_PAUSE);
        delay(250);  
        BLEHidRef->consumerKeyRelease(); 
        delay(250);
        return APP_IS_RUNNING;     
      }
      else if(strapDisplayCoreRef->checkInputRegion(mediaControlsPlayButton)){
        BLEHidRef->consumerKeyPress(HID_USAGE_CONSUMER_PLAY_PAUSE);
        delay(250);  
        BLEHidRef->consumerKeyRelease(); 
        delay(250);
        return APP_IS_RUNNING;     
      }
  
  return APP_IS_RUNNING;
}

void StrapDisplayAppMediaControls::registerBLEHidAdafruit(BLEHidAdafruit *BLEHid){
  BLEHidRef = BLEHid;
}
