#ifndef STRAPDISPLAYAPPMEDIACONTROLS_h
#define STRAPDISPLAYAPPMEDIACONTROLS_h

// Includes
#include "StrapDisplayInputManager.h"
#include "strapDisplayApp.h"
#include "PL_smallLegio.h"
#include <bluefruit.h>

// App Drawer Icon
const unsigned char StrapDisplayAppMediaControls_ICON_RED [] PROGMEM = {0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xc0, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xc0, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xc0, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xc0, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xc0, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xc0, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xc0, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xc0, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xc0, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xc0, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xc0, 0xff, 0xff, 0xfe, 0xff, 0xff, 0xff, 0xc0, 0xff, 0xff, 0xfe, 0x7f, 0xff, 0xff, 0xc0, 0xff, 0xff, 0xfc, 0x7f, 0xff, 0xff, 0xc0, 0xff, 0xff, 0xfc, 0x3f, 0xff, 0xff, 0xc0, 0xff, 0xff, 0xf8, 0x3f, 0xff, 0xff, 0xc0, 0xff, 0xff, 0xf8, 0x1f, 0xff, 0xff, 0xc0, 0xff, 0xff, 0xf0, 0x1f, 0xff, 0xff, 0xc0, 0xff, 0xff, 0xf0, 0x0f, 0xff, 0xff, 0xc0, 0xff, 0xff, 0xe0, 0x0f, 0xff, 0xff, 0xc0, 0xff, 0xff, 0xe0, 0x07, 0xff, 0xff, 0xc0, 0xff, 0xff, 0xc0, 0x07, 0xff, 0xff, 0xc0, 0xff, 0xff, 0xc0, 0x03, 0xff, 0xff, 0xc0, 0xff, 0xff, 0x80, 0x03, 0xff, 0xff, 0xc0, 0xff, 0xff, 0x80, 0x01, 0xff, 0xff, 0xc0, 0xff, 0xff, 0x00, 0x01, 0xff, 0xff, 0xc0, 0xff, 0xff, 0x00, 0x00, 0xff, 0xff, 0xc0, 0xff, 0xfe, 0x00, 0x00, 0xff, 0xff, 0xc0, 0xff, 0xfe, 0x00, 0x00, 0x7f, 0xff, 0xc0, 0xff, 0xfc, 0x00, 0x00, 0x7f, 0xff, 0xc0, 0xff, 0xfc, 0x00, 0x00, 0x3f, 0xff, 0xc0, 0xff, 0xf8, 0x00, 0x00, 0x3f, 0xff, 0xc0, 0xff, 0xf8, 0x00, 0x00, 0x1f, 0xff, 0xc0, 0xff, 0xf0, 0x00, 0x00, 0x0f, 0xff, 0xc0, 0xff, 0xf0, 0x00, 0x00, 0x0f, 0xff, 0xc0, 0xff, 0xe0, 0x00, 0x00, 0x07, 0xff, 0xc0, 0xff, 0xe0, 0x00, 0x00, 0x07, 0xff, 0xc0, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xc0, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xc0, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xc0, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xc0, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xc0, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xc0, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xc0, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xc0, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xc0, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xc0, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xc0, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xc0, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xc0};

// StrapDisplayAppMediaControls Class
class StrapDisplayAppMediaControls : public StrapDisplayApp{

  private:
  InputRegion mediaControlsAppButton;
  InputRegion mediaControlsBackButton;
  InputRegion mediaControlsNextButton;
  InputRegion mediaControlsPrevButton;
  InputRegion mediaControlsMuteButton;
  InputRegion mediaControlsIncreaseButton;
  InputRegion mediaControlsDecreaseButton;
  InputRegion mediaControlsPauseButton;
  InputRegion mediaControlsPlayButton;
  BLEHidAdafruit *BLEHidRef;
  
  public:
  void init();
  void registerBLEHidAdafruit(BLEHidAdafruit *BLEHid);
  int runApplication();
  void show();
  void drawAppIcon(int xPos, int yPos, int color);


 };
 #endif
