// Includes
#include "StrapDisplayAppMsgCentral.h"
#include "StrapDisplayInputManager.h"
#include "fonts/FreeMonoBold9pt7b.h"

void StrapDisplayAppMsgCentral::show(){

    // Set font and font size
    epdRef->setFont(&FreeMonoBold9pt7b);
    epdRef->setTextSize(1);
  
    epdRef->clearScreen(EPD_BLACK);
    delay(1000);
    
    epdRef->drawBitmap(0,0,SCREEN_BUBBLE,240,146,EPD_BLACK);
    epdRef->drawBitmap(0,0,SCREEN_BUBBLE_BACK,240,146,EPD_BLACK); 

    // ANCS Text
    int maxCharsPerLine = 17;
    int max_lines = 4;
    int currentCharPos=0;

    // Heart Icons
    int hearIconCharIndex = 0;
    int hearIconCharPos = 0;
    int hearIconPosX[10];
    int hearIconPosY[10];
    
    String ancsMSG = strapDisplayANCSmessages[app_internal_state].getANCSAppMessage();
    epdRef->setCursor(0, 38);
        
    for (int i=0; i<max_lines && ancsMSG!="";i++){

      int read_more=0;
      String read_moreTxt="";
      if(i==(max_lines-1)){read_more=0;}
  
      // Format and manually hand breaks in every single text message line...
      String singleLineMsgMax = ancsMSG.substring(currentCharPos,(currentCharPos+(maxCharsPerLine-read_more)));
      String singleLineMsgFormatted = singleLineMsgMax.substring(0,singleLineMsgMax.lastIndexOf(" "));
      currentCharPos = currentCharPos+(singleLineMsgFormatted.length())+1;

      // Remove ASCII emjoicons and save positions to later place icons...
      hearIconCharPos = singleLineMsgFormatted.indexOf("<3");
      while(hearIconCharPos!=-1){
        singleLineMsgFormatted.setCharAt(hearIconCharPos ,' ');
        singleLineMsgFormatted.setCharAt(hearIconCharPos+1,' ');   
        hearIconPosX[hearIconCharIndex] = hearIconCharPos*10+(2*10)+10; // fine-tuning x positioning...
        hearIconPosY[hearIconCharIndex] = ((i*18)+28);                  // fine-tuning y positioning...
        hearIconCharIndex++;
        hearIconCharPos = singleLineMsgFormatted.indexOf("<3");
      }
      
      //if(i==(max_lines-1) && (ancsMSG.length()>currentCharPos)){read_moreTxt=" ...";}
      epdRef->print("  "+singleLineMsgFormatted+read_moreTxt+"\n");
    }

    for(int i = 0;i<hearIconCharIndex;i++){
      epdRef->drawBitmap(hearIconPosX[i],hearIconPosY[i],HEART_BLACK,13,12,EPD_BLACK);
      epdRef->drawBitmap(hearIconPosX[i],hearIconPosY[i],HEART_RED,13,12,EPD_BLACK);  
    }
    
    epdRef->updateLegio(EPD_BLACK);
    
    epdRef->clear();
    for(int i = 0;i<hearIconCharIndex;i++){
       epdRef->drawBitmap(hearIconPosX[i],hearIconPosY[i],HEART_RED,13,12,EPD_BLACK);  
    }
    epdRef->updateLegio(EPD_RED);
    
    epdRef->clear(); 
    epdRef->drawBitmap(0,0,SCREEN_BUBBLE_BACK,240,146,EPD_BLACK); 
    epdRef->updateLegio(EPD_YELLOW);

    if(ancsMSG!=""){
      epdRef->clear(); 
      epdRef->setCursor(70, 122);
      epdRef->print((strapDisplayANCSmessages[app_internal_state].getANCSAppEventType()).substring(0,16));
      //epdRef->print("Amelia Brown");
      epdRef->setCursor(70, 136);
      epdRef->print("via " + strapDisplayANCSmessages[app_internal_state].getANCSAppName());
      //epdRef->print("via Signal");
      epdRef->updateLegio(EPD_BLUE);
    }
    else{
      epdRef->clear(); 
      epdRef->setCursor(44, 58);
      epdRef->print("There are no\n    new messages!");
      epdRef->updateLegio(EPD_BLUE);
      }
    //delay(1000);
}

void StrapDisplayAppMsgCentral::init(){

  // Back to App Drawer exit button
  msgCentralBackButton.minYVal = 650;
  msgCentralBackButton.maxYVal = 750;
  msgCentralBackButton.xVal = softPotLeftID;

  // Previous notification button (left)
  msgCentralPrevButton.minYVal = 650;
  msgCentralPrevButton.maxYVal = 800;
  msgCentralPrevButton.xVal = softPotMiddleID;

  // Next notification button (right)
  msgCentralNextButton.minYVal = 100;
  msgCentralNextButton.maxYVal = 225;
  msgCentralNextButton.xVal = softPotMiddleID;

  // Set font and font size
  epdRef->setFont(&FreeMonoBold9pt7b);
  epdRef->setTextSize(1);
}

void StrapDisplayAppMsgCentral::drawAppIcon(int xPos, int yPos, int color){

  if(color == iconBlackPixel){
      epdRef->drawBitmap(xPos,yPos,StrapDisplayAppMsgCentral_ICON_BLACK,50,50,EPD_BLACK);
      epdRef->drawBitmap(xPos,yPos,StrapDisplayAppMsgCentral_ICON_YELLOW,50,50,EPD_BLACK);
      epdRef->drawBitmap(xPos,yPos,StrapDisplayAppMsgCentral_ICON_RED,50,50,EPD_BLACK);
      epdRef->drawRect(xPos-1,yPos-1,50+2,50+2,EPD_BLACK);
      epdRef->drawRect(xPos-2,yPos-2,50+4,50+4,EPD_BLACK);  
  }
  else if(color == iconRedPixel){
    epdRef->drawBitmap(xPos,yPos,StrapDisplayAppMsgCentral_ICON_RED,50,50,EPD_BLACK);
  }
  else if(color == iconYellowPixel){
    epdRef->drawBitmap(xPos,yPos,StrapDisplayAppMsgCentral_ICON_YELLOW,50,50,EPD_BLACK);
  }
  else if(color == iconBluePixel){
    epdRef->drawBitmap(xPos,yPos,StrapDisplayAppMsgCentral_ICON_BLUE,50,50,EPD_BLACK);
  }  
}

int StrapDisplayAppMsgCentral::runApplication(){  

  // Read SoftPot Values...
  strapDisplayCoreRef->readSoftPots();

  if (strapDisplayCoreRef->checkInputRegion(msgCentralBackButton)) {
        return APP_EXIT;
      }
  else if (strapDisplayCoreRef->checkInputRegion(msgCentralPrevButton)) {
    if((app_internal_state-1)<=0){app_internal_state=msg_index-1;}else{app_internal_state--;}
    show();
    return APP_IS_RUNNING;
  }
  else if (strapDisplayCoreRef->checkInputRegion(msgCentralNextButton)) {
    if((app_internal_state+1)>=msg_index){app_internal_state=0;}else{app_internal_state++;}
    show();
    return APP_IS_RUNNING;
  }
    
  return APP_IS_RUNNING;
}

void StrapDisplayAppMsgCentral::addMessage(StrapDisplayANCSmessage newStrapDisplayANCSmsg){
  if(msg_index == (ANCS_MSG_BUFFER+1)){msg_index=0;}
  strapDisplayANCSmessages[msg_index] = newStrapDisplayANCSmsg;
  app_internal_state = msg_index;
  msg_index++;
}
