// Includes
#include "StrapDisplayAppPattern.h"
#include "StrapDisplayInputManager.h"
#include "screens/app_patterns.h"
#include "screens/app_weather.h"

void StrapDisplayAppPattern::show(){
    epdRef->clearScreen(EPD_BLACK);
    delay(1000);
    epdRef->showImage(SCREEN_PATTERN_II);
    delay(1000);  
}

void StrapDisplayAppPattern::drawAppIcon(int xPos, int yPos, int color){

  if(color == iconBlackPixel){
      epdRef->drawBitmap(xPos,yPos,StrapDisplayAppPattern_ICON_RED,50,50,EPD_BLACK);
      epdRef->drawBitmap(xPos,yPos,StrapDisplayAppPattern_ICON_BLUE,50,50,EPD_BLACK); 
      epdRef->drawRect(xPos-1,yPos-1,50+2,50+2,EPD_BLACK);
      epdRef->drawRect(xPos-2,yPos-2,50+4,50+4,EPD_BLACK);  
  }
  else if(color == iconRedPixel){
    epdRef->drawBitmap(xPos,yPos,StrapDisplayAppPattern_ICON_RED,50,50,EPD_BLACK);
  }
  else if(color == iconYellowPixel){
    epdRef->drawBitmap(xPos,yPos,StrapDisplayAppPattern_ICON_BLUE,50,50,EPD_BLACK);
  } 
}

void StrapDisplayAppPattern::init(){
  patternBackButton.minYVal = 650;
  patternBackButton.maxYVal = 750;
  patternBackButton.xVal = softPotLeftID;
  app_internal_state = 0;
}

int StrapDisplayAppPattern::runApplication(){  

  // Read SoftPot Values...
  strapDisplayCoreRef->readSoftPots();

  if (strapDisplayCoreRef->checkInputRegion(patternBackButton)) {
        return APP_EXIT;
      }
  
  return APP_IS_RUNNING;
}
