// Includes
#include "StrapDisplayAppWatchStrap.h"
#include "StrapDisplayInputManager.h"

void StrapDisplayAppWatchStrap::show(){
    epdRef->clearScreen(EPD_BLACK);
    delay(1000);
    epdRef->showImage(SCREEN_HEALTH);
    delay(1000);  
}

void StrapDisplayAppWatchStrap::drawAppIcon(int xPos, int yPos, int color){

  if(color == iconBlackPixel){
      epdRef->drawBitmap(xPos,yPos,StrapDisplayAppWatchStrap_ICON_BLACK,50,50,EPD_BLACK);
      epdRef->drawBitmap(xPos,yPos,StrapDisplayAppWatchStrap_ICON_YELLOW,50,50,EPD_BLACK);
      epdRef->drawRect(xPos-1,yPos-1,50+2,50+2,EPD_BLACK);
      epdRef->drawRect(xPos-2,yPos-2,50+4,50+4,EPD_BLACK);  
  }
  else if(color == iconYellowPixel){
    epdRef->drawBitmap(xPos,yPos,StrapDisplayAppWatchStrap_ICON_YELLOW,50,50,EPD_BLACK);
  }
  else if(color == iconBluePixel){
    epdRef->drawBitmap(xPos,yPos,StrapDisplayAppWatchStrap_ICON_BLUE,50,50,EPD_BLACK);
  }
}

void StrapDisplayAppWatchStrap::init(){
  watchStrapBackButton.minYVal = 650;
  watchStrapBackButton.maxYVal = 750;
  watchStrapBackButton.xVal = softPotLeftID;
  app_internal_state = 0;
}

int StrapDisplayAppWatchStrap::runApplication(){  

  // Read SoftPot Values...
  strapDisplayCoreRef->readSoftPots();

  if (strapDisplayCoreRef->checkInputRegion(watchStrapBackButton)) {
        return APP_EXIT;
      }
  
  return APP_IS_RUNNING;
}
