// Includes
#include "strapDisplayAppPedometer.h"
#include "StrapDisplayInputManager.h"
#include "screens/app_weather.h"
#include "strapDisplayAppWeather.h"        
        
void StrapDisplayAppWeather::show(){
  switch(app_internal_state){
    case 0:
      epdRef->clearScreen(EPD_BLACK);
      delay(1000);
      epdRef->showImage(SCREEN_DASHBOARD);
      delay(1000);
      break;
    case 1:
      epdRef->clearScreen(EPD_BLACK);
      delay(1000);
      epdRef->showImage(SCREEN_MONDAY);
      delay(1000);
      break;
     case 3:
      epdRef->clearScreen(EPD_BLACK);
      delay(1000);
      epdRef->showImage(SCREEN_WEDNESDAY);
      delay(1000);
      break;
  }
}

void StrapDisplayAppWeather::init(){

  // Monday Button
  mondayButton.minYVal = 80;
  mondayButton.maxYVal = 300;
  mondayButton.xVal = softPotLeftID;

  // Monday Back Button
  mondayBackButton.minYVal = 650;
  mondayBackButton.maxYVal = 750;
  mondayBackButton.xVal = softPotLeftID;

  // Wednesday Button
  wednesdayButton.minYVal = 80;
  wednesdayButton.maxYVal = 300;
  wednesdayButton.xVal = softPotRightID;

  // Wednesday Back Button
  wednesdayBackButton.minYVal = 650;
  wednesdayBackButton.maxYVal = 750;
  wednesdayBackButton.xVal = softPotLeftID;

  // Weather Back Button
  weatherBackButton.minYVal = 650;
  weatherBackButton.maxYVal = 750;
  weatherBackButton.xVal = softPotLeftID;

  app_internal_state = 0;
}

void StrapDisplayAppWeather::drawAppIcon(int xPos, int yPos, int color){

  if(color == iconBlackPixel){
      epdRef->drawBitmap(xPos,yPos,StrapDisplayAppWeather_ICON_BLACK,50,50,EPD_BLACK);
      epdRef->drawRect(xPos-1,yPos-1,50+2,50+2,EPD_BLACK);
      epdRef->drawRect(xPos-2,yPos-2,50+4,50+4,EPD_BLACK);  
  }
  else if(color == iconBluePixel){
    epdRef->drawBitmap(xPos,yPos,StrapDisplayAppWeather_ICON_BLUE,50,50,EPD_BLACK);
  } 
}


int StrapDisplayAppWeather::runApplication(){  

  // Read SoftPot Values...
  strapDisplayCoreRef->readSoftPots();

    switch(app_internal_state){
      case 0:
        if (strapDisplayCoreRef->checkInputRegion(weatherBackButton)) {
            return APP_EXIT;
          }
        else if (strapDisplayCoreRef->checkInputRegion(mondayButton)){
            app_internal_state = 1;
            show();
            return APP_IS_RUNNING;
         }
        else if (strapDisplayCoreRef->checkInputRegion(wednesdayButton)){
            app_internal_state = 3;
            show();
            return APP_IS_RUNNING;
        }
        break;
        
      case 1:
        if (strapDisplayCoreRef->checkInputRegion(mondayBackButton)) {
          app_internal_state = 0;
          show();
          return APP_IS_RUNNING;
        }
        break;  

      case 3:
        if (strapDisplayCoreRef->checkInputRegion(wednesdayBackButton)) {
          app_internal_state = 0;
          show();
          return APP_IS_RUNNING;
        }
        break;  
         
     }

  // no user input => app running
  return APP_IS_RUNNING;
}
