// Includes
#include "StrapDisplayAppWorkWear.h"
#include "StrapDisplayInputManager.h"

void StrapDisplayAppWorkWear::show(){

    // Clear
    epdRef->clearScreen(EPD_BLACK);
    
    delay(1000);

    // Draw all color layers
    int xPos,yPos=0;
    epdRef->drawBitmap(xPos,yPos,MEDICAL_BLACK,240,146,EPD_BLACK);
    epdRef->drawBitmap(xPos,yPos,MEDICAL_YELLOW,240,146,EPD_BLACK);
    epdRef->drawBitmap(xPos,yPos,MEDICAL_RED,240,146,EPD_BLACK);
    epdRef->drawBitmap(xPos,yPos,MEDICAL_GREEN,240,146,EPD_BLACK);
    epdRef->updateLegio(EPD_BLACK);
    epdRef->clear();
    epdRef->drawBitmap(xPos,yPos,MEDICAL_RED,240,146,EPD_BLACK);
    epdRef->updateLegio(EPD_RED);
    epdRef->clear();
    epdRef->drawBitmap(xPos,yPos,MEDICAL_YELLOW,240,146,EPD_BLACK);
    epdRef->drawBitmap(xPos,yPos,MEDICAL_GREEN,240,146,EPD_BLACK);
    epdRef->updateLegio(EPD_YELLOW);
    epdRef->clear();
    epdRef->drawBitmap(xPos,yPos,MEDICAL_GREEN,240,146,EPD_BLACK);
    epdRef->updateLegio(EPD_GREEN);
    epdRef->clear();
    epdRef->drawBitmap(xPos,yPos,MEDICAL_BLUE,240,146,EPD_BLACK);
    epdRef->updateLegio(EPD_BLUE);
    epdRef->clear();
}

void StrapDisplayAppWorkWear::drawAppIcon(int xPos, int yPos, int color){

  if(color == iconBlackPixel){
      epdRef->drawBitmap(xPos,yPos,StrapDisplayAppWorkWear_ICON_RED,50,50,EPD_BLACK);
      epdRef->drawRect(xPos-1,yPos-1,50+2,50+2,EPD_BLACK);
      epdRef->drawRect(xPos-2,yPos-2,50+4,50+4,EPD_BLACK);  
  }
  else if(color == iconRedPixel){
    epdRef->drawBitmap(xPos,yPos,StrapDisplayAppWorkWear_ICON_RED,50,50,EPD_BLACK);
  }
}

void StrapDisplayAppWorkWear::init(){
  workWearBackButton.minYVal = 650;
  workWearBackButton.maxYVal = 750;
  workWearBackButton.xVal = softPotLeftID;
  app_internal_state = 0;
}

int StrapDisplayAppWorkWear::runApplication(){  

  // Read SoftPot Values...
  strapDisplayCoreRef->readSoftPots();

  if (strapDisplayCoreRef->checkInputRegion(workWearBackButton)) {
        return APP_EXIT;
      }
  
  return APP_IS_RUNNING;
}
